require File.dirname(__FILE__) + '/../test_helper'
require 'bitem_controller'

# Re-raise errors caught by the controller.
class BitemController; def rescue_action(e) raise e end; end

class BitemControllerTest < Test::Unit::TestCase
  fixtures :bitems

  def setup
    @controller = BitemController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = bitems(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:bitems)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:bitem)
    assert assigns(:bitem).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:bitem)
  end

  def test_create
    num_bitems = Bitem.count

    post :create, :bitem => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_bitems + 1, Bitem.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:bitem)
    assert assigns(:bitem).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      Bitem.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      Bitem.find(@first_id)
    }
  end
end
