require File.dirname(__FILE__) + '/../test_helper'
require 'rentable_controller'

# Re-raise errors caught by the controller.
class RentableController; def rescue_action(e) raise e end; end

class RentableControllerTest < Test::Unit::TestCase
  fixtures :rentables

  def setup
    @controller = RentableController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = rentables(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:rentables)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:rentable)
    assert assigns(:rentable).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:rentable)
  end

  def test_create
    num_rentables = Rentable.count

    post :create, :rentable => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_rentables + 1, Rentable.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:rentable)
    assert assigns(:rentable).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      Rentable.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      Rentable.find(@first_id)
    }
  end
end
